// ********************************
// map_smallyard.js Script
// ********************************

var MarioIsAlive = true;
var MarioIsBig = false;
var BlockQuestion1Active = true;
var BlockQuestion2Active = true;
SOUND_Doink = LoadSound("doink.wav");
SOUND_Gotit = LoadSound("gotit.wav");

function DisplayWelcome() {
  MsgWelcome = new Array();
  MsgWelcome[0] = "Welcome back!";
  MsgWelcome[1] = "This time try stomping on koopas,";
  MsgWelcome[2] = "hitting blocks with your head, and";
  MsgWelcome[3] = "picking up mushrooms.  Bad guys";
  MsgWelcome[4] = "can now hurt you, but you will";
  MsgWelcome[5] = "return to life as long as you have";
  MsgWelcome[6] = "lives remaining.  Good luck!";
  MsgWelcome[7] = " ";
  ToadSplash(MsgWelcome);
}

// Prevents a live Mario from entering his own Bardo
function TryEnterBardoHeroes() {
  if (MarioIsAlive) {
    Hint = new Array();
    Hint[0] = "Sorry, you may not enter your";
    Hint[1] = "own bardo unless you are dead.";
    Hint[2] = " ";
    DeathSplash(Hint);
    GetKickedBy("DeathHimself",true);
  }
}

// Prevents from entering the badguys Bardo
function TryEnterBardoBadguys() {
  Hint = new Array();
  Hint[0] = "Sorry, you may not enter the";
  Hint[1] = "bad guys bardo, live or dead.";
  Hint[2] = " ";
  DeathSplash(Hint);
  GetKickedBy("DeathHimself",true);
}

function PunchBlockQuestion(BlockName) {
switch (BlockName) {
  case "BlockQuestion1": var BQActive = BlockQuestion1Active; break;
  case "BlockQuestion2": var BQActive = BlockQuestion2Active; break;
}
if (BQActive) {
  var ActName = GetInputPerson();
  var ActDir = GetPersonDirection(ActName);
  switch (ActDir) {
   case "north":
     switch (BlockName) {
       case "BlockQuestion1": 
         BlockQuestion1Active = false; 
         PopOutShroom(BlockName,"green");
         break;
       case "BlockQuestion2": 
         BlockQuestion2Active = false; 
         PopOutShroom(BlockName,"red");
         break;
     }
     if (SOUND_Doink.isPlaying) { SOUND_Doink.stop(); }
     SOUND_Doink.play(false);
     QPC(BlockName, COMMAND_FACE_SOUTH,true,1);
     GetKickedBy(BlockName,true);   
     break;
    default:
      break;
  } 
}
}

function PickUpShroom(ShroomName, ShroomColor) {
  //myLog.write("Now PickUpShroom-ing: " + ShroomName + ":" + ShroomColor);
  if (SOUND_Gotit.isPlaying) { SOUND_Gotit.stop(); }
  SOUND_Gotit.play(false);  
  switch(ShroomColor) {
    case "red":
      MarioScore = MarioScore + 20;
      if (!MarioIsBig) {
        MarioIsBig = true;
        var xxx = GetPersonX(GetInputPerson());
        var yyy = GetPersonY(GetInputPerson());
	var CharName = "PCMario1";
	DetachCamera();
	DetachInput();
        DestroyPerson(CharName)
        CreatePerson(CharName, "supermario.rss", false);
        SetPersonX(CharName, xxx);
        SetPersonY(CharName, yyy);
        AttachInput(CharName);
        AttachCamera(CharName);        
      }     
      QPC("BlockQuestion2", COMMAND_FACE_NORTH, true, 1);
      BlockQuestion2Active = true;
      break;
    case "green":
      MarioScore = MarioScore + 20;
      MarioLives = MarioLives + 1;
      QPC("BlockQuestion1", COMMAND_FACE_NORTH, true, 1);
      BlockQuestion1Active = true;
      break;
  }
  DestroyPerson(ShroomName);
}
  
// Pops a shroom out of a block
function PopOutShroom(FromBlock,Color) {
      var NewName = FromBlock + "shroom" + Color;
      NewShroom = CreatePerson(NewName, "shroom" + Color + ".rss", true);
      SetPersonX(NewName, GetPersonX(FromBlock));
      SetPersonY(NewName, GetPersonY(FromBlock) - 16);
//      SetPersonScript(NewName, SCRIPT_COMMAND_GENERATOR, Wander(NewName)); - Nope, only does it once
//      SetPersonScript(NewName, SCRIPT_COMMAND_GENERATOR, Wander(GetCurrentPerson())); - Nope, moves the blocks
//      SetPersonScript(NewName, SCRIPT_COMMAND_GENERATOR, ShroomWander(NewName)); - Never returns to flip block
      SetPersonScript(NewName, SCRIPT_COMMAND_GENERATOR, "Wander('" + NewName + "')"); 
      SetPersonScript(NewName, SCRIPT_ON_ACTIVATE_TOUCH, "PickUpShroom('" + NewName +"', '" + Color + "')");
}

// Deals with touching bad guys
function KissBadGuy(BadGuyName) {
  var ActName = GetInputPerson();
  var ActDir = GetPersonDirection(ActName);
  switch (ActDir) {
   case "north": var MarioWins = 0; break;
   case "east": var MarioWins = 0; break;
   case "south": var MarioWins = 1; break;
   case "west": var MarioWins = 0; break;
   default: var MarioWins = 2;
   }
   switch (MarioWins) {
     case 0:
       // Mario loses
       KillMario(); break;
     case 1:
       // Mario wins
       KillBadGuy(BadGuyName); break;
     default:
   }
}

function KillBadGuy(BadGuyName) {
  if (SOUND_Punch.isPlaying) { SOUND_Punch.stop(); }
  SOUND_Punch.play(false);  
  MarioScore = MarioScore + 100;
  SetPersonX(BadGuyName, 18*16 + 8);
  SetPersonY(BadGuyName, 9*16 + 8);
  // Send him to the Bardo and relaunch!
  ClearPersonCommands(BadGuyName);
  QPC(BadGuyName, COMMAND_MOVE_NORTH, false, 48);
  QPC(BadGuyName, COMMAND_WAIT, false, 32);
}

function KillMario() {
  var CharName = "PCMario1";
  if (SOUND_Chomp.isPlaying) { SOUND_Chomp.stop(); }
  SOUND_Chomp.play(false);  
  if (MarioIsBig) {
        MarioIsBig = false;
        var xxx = GetPersonX(GetInputPerson());
        var yyy = GetPersonY(GetInputPerson());
	DetachCamera();
	DetachInput();
        DestroyPerson(CharName)
        CreatePerson(CharName, "mario.rss", false);
        SetPersonX(CharName, xxx);
        SetPersonY(CharName, yyy);
        AttachInput(CharName);
        AttachCamera(CharName);            
  } else {
    MarioLives = MarioLives - 1;
    if (MarioLives <= 0) {
      Hint = new Array();
      Hint[0] = "Sorry Mario, you are dead.";    
      Hint[1] = "You managed to score " + MarioScore + " points.";
      if (MarioScore < 1000) { 
        Hint[2] = "Your overall performance was pathetic.";
      } else {
        if (MarioScore < 2000) { 
          Hint[2] = "Your overall performance was adequate.";
        } else {
          Hint[2] = "Your overall performance was impressive.";
        }
      }
      Hint[3] = " ";
      DeathSplash(Hint);    
      ExitMapEngine();
      ClearScreen();        
      FlipScreen();
      Hint2 = new Array();
      Hint2[0] = "GAME OVER";
      Hint2[1] = " ";
      ToadSplash(Hint2);    
    } else {
      Hint = new Array();
      if (MarioLives > 1) {
        Hint[0] = "You now have " + MarioLives + " lives remaining.";    
      } else {
        Hint[0] = "You now have only 1 life left!";    
      }
      Hint[1] = "Your score is currently " + MarioScore + " points.";
      Hint[2] = " ";
      DeathSplash(Hint);    
      SetPersonX(CharName, 5*16+8);
      SetPersonY(CharName, 9*16+8);      
    }   
  }
}
