// ********************************
// motion.js Script
// ********************************

SOUND_Punch =  LoadSound("punch.wav");
SOUND_Chomp =  LoadSound("chomp.wav");
  
// Pushes the named entity in the direction 
function Push(TargetName) {

var ActName = GetInputPerson();
var ActDir = GetPersonDirection(ActName);
// Recommend NO SOUND if "pixel-pushing"
switch (ActDir) {
  case "east":
    QueuePersonCommand(TargetName, COMMAND_MOVE_EAST, true);
    break;
  case "west":
    QueuePersonCommand(TargetName, COMMAND_MOVE_WEST, true);
    break;
  case "north":
    QueuePersonCommand(TargetName, COMMAND_MOVE_NORTH, true);
    break;
  case "south":
    QueuePersonCommand(TargetName, COMMAND_MOVE_SOUTH, true);
    break;
  default:
    break;
} }

// Kicks the named entity in the direction 
function Kick(TargetName) {

var ActName = GetInputPerson();
var ActDir = GetPersonDirection(ActName);
var KickDist = 8;
var SlideDist = 16;
// PlaySound("punch.wav"); - TOO SLOW!!!
if ( ActDir == "east" || ActDir == "west" || ActDir == "north" || ActDir == "south" ) {
  if (SOUND_Punch.isPlaying) { SOUND_Punch.stop(); }
  SOUND_Punch.play(false);
} 
switch (ActDir) {
  case "east":
    QPC(TargetName, COMMAND_MOVE_EAST,true,KickDist);
    QPC(TargetName, COMMAND_MOVE_EAST,false,SlideDist);
    break;
  case "west":
    QPC(TargetName, COMMAND_MOVE_WEST,true,KickDist);
    QPC(TargetName, COMMAND_MOVE_WEST,false,SlideDist);
    break;
  case "north":
    QPC(TargetName, COMMAND_MOVE_NORTH,true,KickDist);
    QPC(TargetName, COMMAND_MOVE_NORTH,false,SlideDist);
    break;
  case "south":
    QPC(TargetName, COMMAND_MOVE_SOUTH,true,KickDist);
    QPC(TargetName, COMMAND_MOVE_SOUTH,false,SlideDist);
    break;
  default:
    break;
} }

function QPC(TargetName, Direction, DoItNow, ActCount) {
var i;
for (i=0;i<ActCount;i++) {
    QueuePersonCommand(TargetName, Direction, DoItNow);
} }

// Lets the named entity kick you  
function GetKickedBy(TargetName, Silent) {

var ActName = GetInputPerson();
var ActDir = GetPersonDirection(ActName);
TargetName = ActName;
var KickDist = 16;
var SlideDist = 0;
// PlaySound("punch.wav"); - TOO SLOW!!!
if (!Silent) {
  if ( ActDir == "east" || ActDir == "west" || ActDir == "north" || ActDir == "south" ) {
    if (SOUND_Chomp.isPlaying) { SOUND_Chomp.stop(); }
    SOUND_Chomp.play(false);
  } 
}
switch (ActDir) {
  case "west":
    QPC(TargetName, COMMAND_MOVE_EAST,true,KickDist);
    QPC(TargetName, COMMAND_MOVE_EAST,false,SlideDist);
    break;
  case "east":
    QPC(TargetName, COMMAND_MOVE_WEST,true,KickDist);
    QPC(TargetName, COMMAND_MOVE_WEST,false,SlideDist);
    break;
  case "south":
    QPC(TargetName, COMMAND_MOVE_NORTH,true,KickDist);
    QPC(TargetName, COMMAND_MOVE_NORTH,false,SlideDist);
    break;
  case "north":
    QPC(TargetName, COMMAND_MOVE_SOUTH,true,KickDist);
    QPC(TargetName, COMMAND_MOVE_SOUTH,false,SlideDist);
    break;
  default:
    break;
} }

// Makes the target wander for a few blocks in a general direction
function Wander(TargetName) {
  var randNS = Math.floor(Math.random()*2);
  var randEW = Math.floor(Math.random()*2);
  var blockWander = 6;
  var blockSize = 16;
  var randWander;
  var i;
  var dirWander;
  // myLog.write("Now Wander-ing: " + TargetName);
  // First figure out which two directions we are allowed to wander in
  switch(randNS){
    case(0): var dirNS = COMMAND_MOVE_NORTH; break;
    case(1): var dirNS = COMMAND_MOVE_SOUTH; break;
  }
  switch(randEW){
    case(0): var dirEW = COMMAND_MOVE_EAST; break;
    case(1): var dirEW = COMMAND_MOVE_WEST; break;
  }
  // Now figure out how that path will be wandered
  for (i=0;i<blockWander;i++) {
    randWander = Math.floor(Math.random()*3);  
    switch(randWander){
      case(0): dirWander = COMMAND_WAIT; break;
      case(1): dirWander = dirNS; break;
      case(2): dirWander = dirEW; break;
    }
    QPC(TargetName, dirWander,false,blockSize);    
  }
}

// Nothing function
function DoNull() {}
